diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
index 84bcd719c..e4b9000c0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectWorld.java
@@ -256,7 +256,7 @@ public class ScreenSelectWorld extends Screen
     public void render(int mx, int my, float partialTick)
     {
         worldSlotContainer.render(mx, my, partialTick);
-        drawStringCentered(font, stringTitle, width / 2, 20, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, stringTitle, width / 2, 20, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
@@ -345,9 +345,9 @@ public class ScreenSelectWorld extends Screen
                 }
             }
 
-            drawString(font, s, x + 2, y + 1, 0xffffff);
-            drawString(font, s1, x + 2, y + 12, 0x808080);
-            drawString(font, s2, x + 2, y + 12 + 10, 0x808080);
+            drawStringShadow(fontRenderer, s, x + 2, y + 1, 0xffffff);
+            drawStringShadow(fontRenderer, s1, x + 2, y + 12, 0x808080);
+            drawStringShadow(fontRenderer, s2, x + 2, y + 12 + 10, 0x808080);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 9a423b1d7..9c63e80d4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -151,7 +151,7 @@ public class ScreenSignEditor extends Screen
             }
         }
         renderBackground();
-        drawStringCentered(font, screenTitle, width / 2, 40, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, screenTitle, width / 2, 40, 0xffffff);
         GL11.glPushMatrix();
         GL11.glTranslatef((float) width / 2, 0.0F, 50F);
         float scale = 93.75F;
@@ -190,7 +190,7 @@ public class ScreenSignEditor extends Screen
         entitySign.lineBeingEdited = -1;
         GL11.glPopMatrix();
         
-        drawStringCentered(font, I18n.getInstance().translateKey(entitySign.getPicture().getLanguageKey()), width / 2, 100 + 50 + yOffset, 0xFFFFFF);
+        drawStringCenteredShadow(fontRenderer, I18n.getInstance().translateKey(entitySign.getPicture().getLanguageKey()), width / 2, 100 + 50 + yOffset, 0xFFFFFF);
 
         super.render(mx, my, partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
index cda236899..a87899095 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
+import net.minecraft.client.render.font.Alignment;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.sound.SoundEvent;
@@ -10,7 +11,7 @@ import net.minecraft.client.sound.SoundRepository;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.helper.Utils;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -156,21 +157,16 @@ public class ScreenSoundTest extends Screen {
 
         super.render(mx, my, partialTick);
 
-        font.drawCenteredString(I18n.getInstance().translateKey("gui.sound_test.label.title"), width/2, 5, 0xFFFFFF);
+        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.sound_test.label.title"), width/2, 5, 0xFFFFFF);
 
-        String msg = I18n.getInstance().translateKey("gui.sound_test.label.select_entry");
-        font.drawString(msg, leftEntry.getX() - BUTTON_SPACING - font.getStringWidth(msg), leftEntry.getY() + 6, 0xFFFFFF);
+        final String msg = I18n.getInstance().translateKey("gui.sound_test.label.select_entry");
+        drawStringNoShadow(this.fontRenderer, msg, leftEntry.getX() - BUTTON_SPACING - MathHelper.ceil(fontRenderer.stringWidthDouble(msg)), leftEntry.getY() + 6, 0xFFFFFF);
 
         StringBuilder builder = new StringBuilder();
-        builder.append(font.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.getEventID()), width - 10)).append("\n");
-        builder.append(font.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.subtitle", currentEntry == null ? null : currentEntry.getSubtitleKey(), currentEntry == null ? null : currentEntry.getSubtitleTranslated()), width - 10)).append("\n");
-//        builder.append(fontRenderer.wrapFormattedStringToWidth(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.url", String.valueOf(currentEntry == null ? null : (showURL ? currentEntry.url : "REDACTED"))), width - 10)).append("\n");
-        String[] lines = builder.toString().split("\n");
-        int y = top + 30;
-        for (String line : lines) {
-            font.drawString(line, 5, y, 0xBBBBBB);
-            y += 10;
-        }
+        builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.id", currentEntry == null ? null : currentEntry.getEventID())).append("\n");
+        builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.subtitle", currentEntry == null ? null : currentEntry.getSubtitleKey(), currentEntry == null ? null : currentEntry.getSubtitleTranslated())).append("\n");
+//        builder.append(I18n.getInstance().translateKeyAndFormat("gui.sound_test.label.url", String.valueOf(currentEntry == null ? null : (showURL ? currentEntry.url : "REDACTED")))).append("\n");
+        fontRenderer.renderWidthConstrained(Tessellator.instance, builder, 5, top + 30, 0, true, 0xBBBBBB, width - 10, Alignment.LEFT, null, null, null);
     }
     @Override
     public void renderBackground() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
index 0f5b492d5..51c21e870 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
@@ -9,6 +9,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
@@ -98,7 +99,7 @@ public class ScreenStats extends Screen {
 	public void render(int mx, int my, float partialTick)
     {
         selectionList.render(mx, my, partialTick);
-        drawStringCentered(font, title, width / 2, 20, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, title, width / 2, 20, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
@@ -236,11 +237,11 @@ public class ScreenStats extends Screen {
             if(statItem != null)
             {
                 String s = statItem.getFormattedValue(statsCounter.readStat(statItem));
-                drawString(font, s, x - font.getStringWidth(s), y + 5, white ? 0xffffff : 0x909090);
+                drawStringShadow(fontRenderer, s, x - MathHelper.ceil(fontRenderer.stringWidthDouble(s)), y + 5, white ? 0xffffff : 0x909090);
             } else
             {
                 String s1 = "-";
-                drawString(font, s1, x - font.getStringWidth(s1), y + 5, white ? 0xffffff : 0x909090);
+                drawStringShadow(fontRenderer, s1, x - MathHelper.ceil(fontRenderer.stringWidthDouble(s1)), y + 5, white ? 0xffffff : 0x909090);
             }
         }
 
@@ -348,9 +349,9 @@ public class ScreenStats extends Screen {
         protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
         {
             Stat stat = StatList.basicStats.get(index);
-            drawString(font, stat.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
+            drawStringShadow(fontRenderer, stat.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
             String s = stat.getFormattedValue(statsCounter.readStat(stat));
-            drawString(font, s, (x + 2 + 213) - font.getStringWidth(s), y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
+            drawStringShadow(fontRenderer, s, (x + 2 + 213) - MathHelper.ceil(fontRenderer.stringWidthDouble(s)), y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
index d266bd799..58517d278 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
@@ -8,7 +8,6 @@ import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.util.helper.Utils;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -119,7 +118,7 @@ public class ScreenTextureViewer extends Screen {
     public void render(int mx, int my, float partialTick) {
         renderBackground();
 
-        font.drawCenteredString(I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
+        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
 
         List<Integer> textureList = GLAllocation.textureNames;
         int id = texIndex % textureList.size();
@@ -187,9 +186,9 @@ public class ScreenTextureViewer extends Screen {
         GL11.glDisable(GL11.GL_DEPTH_TEST);
 
         if (drawText) {
-            font.drawString("Tex ID: " + id , 1, top + 1, 0xFFFFFF, true);
-            font.drawString("Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF, true);
-            font.drawString("Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF, true);
+            drawStringShadow(this.fontRenderer, "Tex ID: " + id , 1, top + 1, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, "Tex Width: " + texWidth, 1, top + 11, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, "Tex Height: " + texHeight, 1, top + 21, 0xFFFFFF);
 
             String s;
             if (t == null) {
@@ -200,7 +199,7 @@ public class ScreenTextureViewer extends Screen {
             String[] lines = s.split("\n");
             int yOff = top + 31;
             for (String line : lines) {
-                font.drawString(line, 1, yOff, 0xFFFFFF, true);
+                drawStringShadow(fontRenderer, line, 1, yOff, 0xFFFFFF);
                 yOff += 10;
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
index a700f9a70..0f323dda2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
@@ -65,8 +64,7 @@ public class SliderElement extends ButtonElement {
 	{
 		if (!visible) return;
 
-		Font font = mc.font;
-		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+				boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
@@ -104,7 +102,7 @@ public class SliderElement extends ButtonElement {
 				textColor = 0xFFFFA0;
 				break;
 		}
-		drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+		drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
 	}
 
 	@Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/SwitchElement.java b/game/client/src/main/java/net/minecraft/client/gui/SwitchElement.java
index 138684442..0c110995f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/SwitchElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/SwitchElement.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
@@ -61,7 +60,6 @@ public class SwitchElement
     public void drawButton(Minecraft mc, int mouseX, int mouseY) {
         if (!visible) return;
 
-        Font font = mc.font;
         boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         int state = getButtonState(mouseOver);
         int xBar = on ? (width / 3) + 1 : 0;
@@ -101,6 +99,6 @@ public class SwitchElement
                 textColor = 0xFFFFA0;
                 break;
         }
-        drawStringCentered(font, displayString, xPosition + xBar + width / 3, yPosition + (height - 8) / 2, textColor);
+        drawStringCenteredShadow(mc.font, displayString, xPosition + xBar + width / 3, yPosition + (height - 8) / 2, textColor);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
index c5f4a9852..617eeccf8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -4,8 +4,9 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.input.InputType;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.gui.text.ITextField;
@@ -13,7 +14,7 @@ import net.minecraft.client.gui.text.ITextField;
 public class TextFieldElement extends Gui implements ITextField
 {
 	
-    private final Font font;
+    private final FontRenderer fontRenderer;
     public int xPosition;
     public int yPosition;
     public final int width;
@@ -29,12 +30,12 @@ public class TextFieldElement extends Gui implements ITextField
     public boolean drawBackground = true;
     private TextFieldEditor editor;
 
-    public TextFieldElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
+    public TextFieldElement(Screen parent, FontRenderer fontRenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
     {
         isFocused = false;
         isEnabled = true;
         this.parent = parent;
-        this.font = font;
+        this.fontRenderer = fontRenderer;
         this.xPosition = xPosition;
         this.yPosition = yPosition;
         this.width = width;
@@ -131,40 +132,40 @@ public class TextFieldElement extends Gui implements ITextField
         }
         if (text.isEmpty() && !isFocused)
         {
-            drawString(font, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+            drawStringShadow(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
         }
 
         if(isEnabled)
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / font.getCharWidth('_');
+            int maxDisplayableChars = this.width / fontRenderer.charWidth('_');
 
             if(text.length() <= maxDisplayableChars-1){
-                drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
             } else {
                 //only draw the part of the string that's maxDisplayableChars chars around the cursor
                 int begin = Math.max(0,cursor - maxDisplayableChars);
                 int end = Math.max(maxDisplayableChars,Math.min(text.length(),cursor));
-                drawString(font, text.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawStringShadow(fontRenderer, text.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
             }
             if (drawCursor)
             {
-                int width = font.getStringWidth(text);
+                int width = MathHelper.ceil(fontRenderer.stringWidthDouble(text));
                 if (cursor < text.length())
                 {
-                    width = font.getStringWidth(text.substring(0, cursor));
+                    width = MathHelper.ceil(fontRenderer.stringWidthDouble(text.substring(0, cursor)));
                 }
                 if(width >= this.width-4){
                     // width of the text box - the width of the last character
-                    width = (this.width-4) - font.getStringWidth(text.substring(text.length()-2,text.length()-1));
+                    width = (this.width-4) - MathHelper.ceil(fontRenderer.stringWidthDouble(text.substring(text.length()-2,text.length()-1)));
                 }
-                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2 + 1, 0xE0E0E0);
+                drawStringShadow(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2 + 1, 0xE0E0E0);
             }
         }
         else
         {
-            drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+            drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index 564048e0b..4168675e6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -7,6 +7,9 @@ import com.google.gson.JsonParser;
 import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePack;
@@ -15,12 +18,12 @@ import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.client.render.Font;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -34,10 +37,8 @@ import java.io.InputStreamReader;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.HashMap;
-import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
 
 public class TooltipElement extends Gui
 {
@@ -47,37 +48,44 @@ public class TooltipElement extends Gui
     protected final static Style defaultStyle = new Style("default", "default", 3, 3, 3, 3);
 
     Minecraft mc;
-    Font fr;
+    FontRenderer fontRenderer;
 
     public TooltipElement(Minecraft mc)
     {
         this.mc = mc;
-        this.fr = mc.font;
+        this.fontRenderer = mc.font;
     }
     public static final int BASE_PADDING = 3;
     public static final int LINE_SPACING = 3;
 
-    public void render(String string, int x, int y, int offsetX, int offsetY)
+    public void render(final CharSequence string, final int x, final int y, final int offsetX, final int offsetY) {
+        render(string, x, y, offsetX, offsetY, -1, -1, true);
+    }
+    public void render(final CharSequence chars, int x, int y, int offsetX, int offsetY, int maxWidth, int maxHeight, boolean canOffset)
     {
-        String[] lines = string.split("\n");
-        if(lines.length == 0) return;
+        maxWidth = maxWidth == -1 ? Integer.MAX_VALUE : maxWidth;
+        maxHeight = maxHeight == -1 ? Integer.MAX_VALUE : maxHeight;
 
+        final List<String> lines = new ArrayList<>();
+        this.fontRenderer.splitCharsIntoLines(chars, maxWidth, lines);
         int width = 0;
-        for (String line : lines)
+        for (final String line : lines)
         {
-            width = Math.max(width, fr.getStringWidth(line));
+            width = Math.max(width, this.fontRenderer.stringWidth(line) - 1);
         }
 
-        int height = lines.length * 8 + (lines.length - 1) * LINE_SPACING;
+        final int height = MathHelper.ceil(this.fontRenderer.heightOfLines(lines, maxWidth) - 1);
 
         // Flip tooltip X if it goes offscreen to the right
-        if(x + offsetX + width + BASE_PADDING * 2 > mc.resolution.getScaledWidthScreenCoords())
+        if(canOffset && x + offsetX + width > this.mc.resolution.getScaledWidthScreenCoords())
         {
             offsetX = -offsetX - width;
         }
 
-        // Move tooltip up when it goes offscreen to the bottom
-        offsetY -= Math.max(0, y + height + offsetY + BASE_PADDING * 2 - mc.resolution.getScaledHeightScreenCoords());
+        if (canOffset) {
+            // Move tooltip up when it goes offscreen to the bottom
+            offsetY -= Math.max(0, y + height + offsetY - this.mc.resolution.getScaledHeightScreenCoords());
+        }
 
 
         x += offsetX;
@@ -86,20 +94,17 @@ public class TooltipElement extends Gui
         final int padding = getPadding();
 
         drawBackground(x, y, x + width, y + height);
+//        drawRect(x, y, x + width, y + height, 0xFFFFFFFF);
 
-
-        for(int i = 0; i < lines.length; i++)
-        {
-            fr.drawStringWithShadow(lines[i], x + padding, y + padding + i * (8 + LINE_SPACING), 0xFFFFFF);
-        }
+        FontHelper.renderWidthConstrained(Tessellator.instance, chars, x + padding, y + padding, maxWidth).call(this.fontRenderer);
     }
     public int getPadding(){
-        return BASE_PADDING;
+        return 0;
     }
     public int[] drawBackground(int x, int y, int offsetX, int offsetY, int width, int height){
 //        int targetOffset = 0;
         // Flip tooltip X if it goes offscreen to the right
-        if(x + offsetX + width + BASE_PADDING * 2 > mc.resolution.getScaledWidthScreenCoords())
+        if(x + offsetX + width > mc.resolution.getScaledWidthScreenCoords())
         {
 //            int _offsetX = offsetX;
             offsetX = -offsetX - width;
@@ -107,7 +112,7 @@ public class TooltipElement extends Gui
         }
 
         // Move tooltip up when it goes offscreen to the bottom
-        offsetY -= Math.max(0, y + height + offsetY + BASE_PADDING * 2 - mc.resolution.getScaledHeightScreenCoords());
+        offsetY -= Math.max(0, y + height + offsetY - mc.resolution.getScaledHeightScreenCoords());
 
         x += offsetX;
         y += offsetY;
@@ -122,8 +127,18 @@ public class TooltipElement extends Gui
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
 
-            drawGuiIcon(minX, minY, maxX - minX + BASE_PADDING * 2, maxY - minY + BASE_PADDING * 2, style.getInnerIcon());
-            drawGuiIcon(minX - style.paddingLeft, minY - style.paddingTop, maxX - minX + BASE_PADDING * 2 + style.paddingLeft + style.paddingRight, maxY - minY + BASE_PADDING * 2 + style.paddingTop + style.paddingBottom, style.getBorderIcon());
+            drawGuiIcon(
+                minX - 2,
+                minY - 2,
+                maxX - minX + 4,
+                maxY - minY + 4,
+                style.getInnerIcon());
+            drawGuiIcon(
+                minX - 2 - style.paddingLeft,
+                minY - 2 - style.paddingTop,
+                maxX - minX + 4 + style.paddingLeft + style.paddingRight,
+                maxY - minY + 4 + style.paddingTop + style.paddingBottom,
+                style.getBorderIcon());
 
             GL11.glDisable(GL11.GL_BLEND);
         }
@@ -277,6 +292,7 @@ public class TooltipElement extends Gui
         packs.add(packList.getDefaultTexturePack());
         packs.addAll(packList.selectedPacks);
         final Collection<String> styleIds = new ArrayList<>();
+        styleIds.add("default");
         for (int i = packs.size() - 1; i >= 0; i--) {
             final TexturePack pack = packs.get(i);
             try (final InputStream stylesStream = pack.getResourceAsStream("/assets/minecraft/textures/gui/sprites/tooltip/styles.json")) {
@@ -298,7 +314,6 @@ public class TooltipElement extends Gui
                 LOGGER.error("Error occurred while parsing 'styles.json'!", runtimeException);
             }
         }
-        styleIds.add("default");
 
         for (final String styleId : styleIds) {
             JsonObject properties = null;
